<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Security</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="security">Security</h1>
<h2 id="general-validation">General Validation</h2>
<p>Never trust input regardless of where it is coming from! The responsibility falls on the library functions to ensure that potentially dangerous input does not introduce a security hole. Some sort of sanitation, validation, or quoting must be provided for <strong>all</strong> arguments in a function. This ensures that bad data does not make its way into an SQL string, a filename, an executable, or even another function.</p>
<h2 id="request-validation">Request Validation</h2>
<p>For Plugin Developers, Cacti includes settings to allow you to know when you are using unvalidated data. They include:</p>
<ul>
<li><p>get_filter_request_var('somevariable') - This function call, by default, will validate that the variable <code>$_REQUEST['somevariable']</code> returned is actually an integer, if not, Cacti will block the the page function from continuing.</p></li>
<li><p>get_filter_request_var('somevariable', 'options') - This version of the function can do all sorts of verification and sanitization.</p></li>
<li><p>set_request_var('somevariable', 'somevalue') - This function will set the Cacti request variable superglobal with a value.</p></li>
</ul>
<p>Generally speaking, you should never use either <code>$_GET</code>, <code>$_REQUEST</code> or <code>$_POST</code> in your Cacti code. Use the validators. When you do, you can turn on the Cacti setting <code>Log Input Validation Issues</code> when you are developing, and you Cacti log will include warnings when an unvalidate variable has been encountered.</p>
<h2 id="prepared-statements">Prepared Statements</h2>
<p>The second method of hardening your Cacti application is through the use of prepared SQL statements. When you use prepared SQL statements, the Database API will validate that all variables have been properly escaped making it much more difficult to perform SQL injection attacks on Cacti.</p>
<p>Examples of non-prepared function calls and prepared include:</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">$somevalue</span> = db_fetch_cell<span class="ot">(</span><span class="st">&quot;SELECT COUNT(*)</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="st">  FROM host</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="st">  WHERE id = </span><span class="kw">$somevariable</span><span class="st">&quot;</span><span class="ot">);</span></a></code></pre></div>
<p>In the case above, it would be very easy to exploit Cacti. The example below is the correct way to protect against attacks.</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">$somevalue</span> = db_fetch_cell_prepared<span class="ot">(</span><span class="st">&#39;SELECT COUNT(*)</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="st">  FROM host</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="st">  WHERE id = ?&#39;</span><span class="ot">,</span></a>
<a class="sourceLine" id="cb2-4" title="4">  <span class="kw">array</span><span class="ot">(</span><span class="kw">$somevariable</span><span class="ot">));</span></a></code></pre></div>
<h2 id="output-escaping">Output Escaping</h2>
<p>Cacti provides an escaping function to reduce the likelihood of XSS vulnerabilities in Cacti leading to expliotation of other Web Sites. Cacti itself has a very restrictive XSS mitigation policy in affect by default, but following proper output escaping minimizes problems.</p>
<p>The following example is how to, and not to escape output:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">print</span> <span class="st">&quot;&lt;tr&gt;&lt;td&gt;&quot;</span> . <span class="kw">$some_variable</span> . <span class="st">&quot;&lt;/td&gt;&lt;/tr&gt;&quot;</span><span class="ot">;</span></a></code></pre></div>
<p>Using the print statement above, for values that come from the database can lead to Stored XSS vunerabilities in your code. So, it's better to use the following:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">print</span> <span class="st">&quot;&lt;tr&gt;&lt;td&gt;&quot;</span> . html_escape<span class="ot">(</span><span class="kw">$some_variable</span><span class="ot">)</span> . <span class="st">&quot;&lt;/td&gt;&lt;/tr&gt;&quot;</span><span class="ot">;</span></a></code></pre></div>
<h2 id="javascript-validation">JavaScript Validation</h2>
<p>Relying on JavaScript-based validation is nice for instant feedback to the user, but should not replace validation checking in the PHP code.</p>
<p>If you follow the simple rules above, your Plugin will be much safer for others to use and will more easily pass internal security and pen tests.</p>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
